/*
 * Wed Aug 12, 2009
 * ----------------
 * ٴλصĿ
 *
 * Sun Aug 23, 2009
 * ----------------
 * Բͨҵֻˣ  hack
 *
 * Jan 2011
 * --------
 * жıҪ volatile ױ)ΣᱻŻ
 *
 * Sun Jan 30, 2011
 * ----------------
 *  4*4 keypad ɨ躯ʦ״̬
 * ȡ EEPROM еĵ绰벢ʾ
 *
 */

#include <avr/io.h>
#include <avr/eeprom.h>    //  eeprom ֧
#include <avr/pgmspace.h>  //  flash ռ֧
#include <avr/interrupt.h>
#include <string.h>
#include "lcd.h"
#include "button.h"
#include "main.h"
#define F_CPU 8000000
#include <util/delay.h>

// 
#define DTMF_ON_DURATION  60     // DTMF źʱ
#define DTMF_OFF_DURATION 60     // DTMF źֹͣʱ

// 4x4  PORTA 
#define KEYPAD_PORT      PORTA
#define KEYPAD_DDR       DDRA
#define KEYPAD_PIN       PINA


#define MAX_NAME_LEN 13 // ֵ󳤶 + 1
#define MAX_NUM_LEN  13 // 绰󳤶 + 1

#define KEY_TABLE_LENGTH 16
const unsigned char keysymbol_table[16] PROGMEM = {'1', '2', '3', 'A',
									         '4', '5', '6', 'B',
									         '7', '8', '9', 'C',
									         '*', '0', '#', 'D'};

const unsigned char keynum_table[16] PROGMEM = {1,   2,  3,  4,
									      5,   6,  7,  8,
									      9,  10, 11, 12,
									     13,  14, 15, 16};

const unsigned char keycode_table[16] PROGMEM = {0xEE, 0xDE, 0xBE, 0x7E,
										   0xED, 0xDD, 0xBD, 0x7D,
										   0xEB, 0xDB, 0xBB, 0x7B,
										   0xE7, 0xD7, 0xB7, 0x77};


const char dedicated_line0[] PROGMEM = "To:";
const char dedicated_line1[] PROGMEM = "My Dear Grandmother.";

const char name_line_spaces[] PROGMEM = "            ";
const char number_line_spaces[] PROGMEM = "                ";

/******************************************************************
 * ߲
 * ----------
 * һȡ 128 ݣÿ 7 λ
 ******************************************************************/
const unsigned char SineTable[128] PROGMEM = {
 64,  67,  70,  73,  76,  79,  82,  85,
 88,  91,  94,  96,  99, 102, 104, 106,
109, 111, 113, 115, 117, 118, 120, 121,
123, 124, 125, 126, 126, 127, 127, 127,
127, 127, 127, 127, 126, 126, 125, 124,
123, 121, 120, 118, 117, 115, 113, 111,
109, 106, 104, 102,  99,  96,  94,  91,
 88,  85,  82,  79,  76,  73,  70,  67,
 64,  60,  57,  54,  51,  48,  45,  42,
 39,  36,  33,  31,  28,  25,  23,  21,
 18,  16,  14,  12,  10,   9,   7,   6,
  4,   3,   2,   1,   1,   0,   0,   0,
  0,   0,   0,   0,   1,   1,   2,   3,
  4,   6,   7,   9,  10,  12,  14,  16,
 18,  21,  23,  25,  28,  31,  33,  36,
 39,  42,  45,  48,  51,  54,  57,  60
};

/******************************************************************
 * x_SW
 * ----
 * Table of x_SW (excess 8): x_SW = ROUND(8*N_samples*f*510/Fck)
 *
 * Ƶ ()
 * ----------
 * 1209 Hz  ---> x_SW = 79
 * 1336 Hz  ---> x_SW = 87
 * 1477 Hz  ---> x_SW = 96
 * 1633 Hz  ---> x_SW = 107
 *
 * Ƶ ()
 * 697 Hz   ---> x_SW = 46
 * 770 Hz   ---> x_SW = 50
 * 852 Hz   ---> x_SW = 56
 * 941 Hz   ---> x_SW = 61
 *
 ******************************************************************/
const unsigned char freqH[4] PROGMEM = {79, 87, 96, 107};     /* Ƶ */
const unsigned char freqL[4] PROGMEM = {46, 50, 56,  61};     /* Ƶ */

// ȫֱ
char lcd_disp_buffer[4][21];  // LCDʾ壬421

volatile uint8_t time_1s_ok;       // 1-second ok
volatile uint8_t time_100ms_ok;    // 100ms flag
volatile uint8_t key_scan_time_ok; // key scan ok

volatile uint8_t time_1s_counter;       // counts the overflow times of timer0
volatile uint8_t time_100ms_counter;    // 100ms counter
volatile uint8_t key_scan_time_counter; // read keys every 10ms

uint8_t return_time;       // automatic time-out

unsigned char state;       // holds the current state, according to "menu.h"

// dtmf źŷصı
volatile uint8_t x_SWa = 0x00; // Step Width of high frequency
volatile uint8_t x_SWb = 0x00; // Step Width of low frequency
uint16_t i_CurSinValA = 0;     // position freq. A in LUT (extended format)
uint16_t i_CurSinValB = 0;     // position freq. B in LUT (extended format)
uint16_t i_TmpSinValA;         // position freq. A in LUT (actual position)
uint16_t i_TmpSinValB;         // position freq. B in LUT (actual position)

/*

timer0 Ƶ = 8000000/64 = 125000 = 1/125000 = 8us
TCNT0 = 6
255-6 = 249 
249 * 8us = 2ms

*/

struct photoram {
	char id[3];
    char name[MAX_NAME_LEN];
    char number[MAX_NUM_LEN];
};


// ƬĽṹ岢ʼ洢 EEPROM 
EEMEM struct {
    char name[MAX_NAME_LEN];
    char number[MAX_NUM_LEN];
}photo[16] = {{"foo1", "123"}, /* foo1 */
              {"foo2", "456"}, /* foo2 */
              {"foo3", "789"}, /* foo3 */
              {"", ""}, /* */
			  {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
			  {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}, /* */
              {"", ""}};/* */

// ԭͶ
void dial_photo(char *number);

// Initialize Timer/Counter 0
void timer0_init(void)
{
    TCNT0 = 0; // start with 0
    TCCR0 = _BV(CS01) | _BV(CS00); //F_CPU/64
}

// Initialize Timer/Counter 2
void timer2_init(void)
{
    TCNT2 = 0;         // start with 0
    TCCR2 = _BV(CS22); //F_CPU/64
}

// Initializate the different modules
void init(void)
{
    DDRA = 0x0F;  //  4*4 
    PORTA = 0xF0; //  4 λ
	
	// 6  button  PORTC 
    DDRC = 0x00;  // Ϊ
    PORTC = 0xFF; // 

    DDRD |= (1 << PD5); // PD5(OCR1A)  dtmf ź

	lcd_init(LCD_DISP_ON);

    DDRB |= (1 << PB7);       // PB7 control MUTE

    timer0_init();            // timer0 init
    timer2_init();            // timer2 init

    TIMSK = _BV(TOIE0) | _BV(TOIE1) | _BV(TOIE2);  // Timer0/1/2 overflow enabled
    TCCR1A = 0x81; //  8 λ PWM 
    TCCR1B = 0x01; // Timer1 Ƶ = ϵͳʱƵ/1
}




// Timer/Counter 0 Overflow Interrupt ISR

ISR(TIMER0_OVF_vect)
{
    TCNT0 = 6; // 2ms interrupt

    if (++key_scan_time_counter >= 5) // check for 10ms, increament counter
    {
		key_scan_time_counter = 0;
		key_scan_time_ok = 1;        // 10ms ready
	
		if (++time_100ms_counter >= 10)
		{
	    	time_100ms_counter = 0;
	    	time_100ms_ok = 1;
		}
	
		if (++time_1s_counter >= 100)
		{
	    	time_1s_counter = 0;
	    	time_1s_ok = 1;
		}
    }
}

// Timer 1 жϷ

ISR(TIMER1_OVF_vect)
{
    if (x_SWa == 0 || x_SWb == 0)
	{
	    // set OCR1A to half width to show the pwm base clearly.
	    // to set timebase=1us or 5us of oszifox to display pwm base wave clearly.
	    // and this way can avoid noise.
	    // This idea was taken from sunge's program.
	    //OCR1A = 127;
	    
	    // set OCR1A to top will output continuous High in OC1A.
	    OCR1A = 255;
 	}
    else
	{
	    // move Pointer about step width aheaed
	    i_CurSinValA += x_SWa;
	    i_CurSinValB += x_SWb;
	    // normalize Temp-Pointer
	    i_TmpSinValA  =  (char)(((i_CurSinValA+4) >> 3)&(0x007F));
	    i_TmpSinValB  =  (char)(((i_CurSinValB+4) >> 3)&(0x007F));
	    // calculate PWM value: high frequency value + 3/4 low frequency value
	    // OCR1A = (unsigned char)(SineTable[i_TmpSinValA] + (SineTable[i_TmpSinValB]-(SineTable[i_TmpSinValB]>>2)));
	    OCR1A = pgm_read_byte(SineTable + i_TmpSinValA) + 
		(pgm_read_byte(SineTable + i_TmpSinValB) - (pgm_read_byte(SineTable + i_TmpSinValB) >> 2));
	}
}

// Timer/Counter 2 Overflow Interrupt ISR

ISR(TIMER2_OVF_vect)
{
}

//  dtmf ź
void dtmf(char digit)
{
	uint8_t i;

    switch (digit)
    {
    	case '0':
			x_SWb = freqL[3];
			x_SWa = freqH[1];
			break;
    	case '1':
			x_SWb = freqL[0];
			x_SWa = freqH[0];
			break;
    	case '2':
			x_SWb = freqL[0];
			x_SWa = freqH[1];
			break;
    	case '3':
			x_SWb = freqL[0];
			x_SWa = freqH[2];
			break;
    	case '4':
			x_SWb = freqL[1];
			x_SWa = freqH[0];
			break;
    	case '5':
			x_SWb = freqL[1];
			x_SWa = freqH[1];
			break;
    	case '6':
			x_SWb = freqL[1];
			x_SWa = freqH[2];
			break;
    	case '7':
			x_SWb = freqL[2];
			x_SWa = freqH[0];
			break;
    	case '8':
			x_SWb = freqL[2];
			x_SWa = freqH[1];
			break;
    	case '9':
			x_SWb = freqL[2];
			x_SWa = freqH[2];
			break;
    }
    
	for (i=0; i<DTMF_ON_DURATION; i++)
		_delay_ms(1);
    x_SWa = 0;
    x_SWb = 0;
	for (i=0; i<DTMF_OFF_DURATION; i++)
		_delay_ms(1);
}


/******************************************************************
 * button scan state machine
 *****************************************************************/
uint8_t read_button(void)
{
    static uint8_t key_state = 0, key_press;
    uint8_t key_return = KEY_NO; // KEY_NO = 0

    key_press = KEY_INPUT & KEY_MASK; // read the port

    switch (key_state)
    {
        case KEY_STATE_0:  // intial state
            if (key_press != KEY_MASK) key_state = KEY_STATE_1; 
            break;           // key pressed, jump to state 1
        case KEY_STATE_1:    // confirm state
            if (key_press == (KEY_INPUT & KEY_MASK)) // if the key is same
            {
                if (key_press == 0xFE)      // 0b1111 1110
                    key_return = KEY_ESC;   // return the key code
                else if (key_press == 0xFD) // 0b1111 1101
                    key_return = KEY_UP;
                else if (key_press == 0xFB) // 0b1111 1011
                    key_return = KEY_ENTER;
                else if (key_press == 0xF7) // 0b1111 0111
                    key_return = KEY_LEFT;
                else if (key_press == 0xEF) // 0b1110 1111
                    key_return = KEY_DOWN;
                else if (key_press == 0xDF) // 0b1101 1111
                    key_return = KEY_RIGHT;                
                key_state = KEY_STATE_2;    // switch to release state
            }
            else
                key_state = KEY_STATE_0; // key has been release, swith to initial state
            break;
        case KEY_STATE_2:
            if (key_press == KEY_MASK) key_state = KEY_STATE_0; // key has been release, switch to initial state
            break;
    }

    return key_return;
}

uint8_t keypad_scan(void)
{
	uint8_t keycode;

    KEYPAD_DDR = 0x0f;  // 4λ룬4λ
    KEYPAD_PORT = 0xf0; // 4λ
    _delay_us(5);
    keycode = KEYPAD_PIN; // ʱ˿ڵֵ

    KEYPAD_DDR = 0xf0;  // ת4λ4λ
    KEYPAD_PORT = 0x0f; // 4λ
    _delay_us(5);
    keycode |= KEYPAD_PIN; // ˿ֵ, 
	
    return keycode;
}

uint8_t keypad_lookup(uint8_t keycode)
{
	uint8_t i;
	uint8_t keysymbol = 0xFF; // default is invalid

	// check for keycode
	if (keycode != 0xFF)
	{
		// compile default code unless using keypad as keyboard
		// loop through entire table
		for (i=0; i<KEY_TABLE_LENGTH; i++)
		{
			// lookup keycode
			if (pgm_read_byte(keycode_table + i) == keycode)
			{
				// lookup keysymbol
				keysymbol = pgm_read_byte(keysymbol_table + i);
				break;
			}
		}
	}

	// return keysymbol, 0xFF if invalid
	return keysymbol;
}

uint8_t keynum_lookup(uint8_t keysymbol)
{
	uint8_t i;
	uint8_t keynum = 0xFF; // default is invalid

	// check for keysymbol
	if (keysymbol != 0xFF)
	{
		// compile default code unless using keypad as keyboard
		// loop through entire table
		for (i=0; i<KEY_TABLE_LENGTH; i++)
		{
			// lookup keycode
			if (pgm_read_byte(keysymbol_table + i) == keysymbol)
			{
				// lookup keynum
				keynum = pgm_read_byte(keynum_table + i);
				break;
			}
		}
	}

	// return keynum, 0xFF if invalid
	return keynum;
}

/******************************************************************
 * 4*4 keypad scan state machine
 *****************************************************************/
uint8_t keypad_get_key(void)
{
    static uint8_t key_state = 0, keymaybe, keycode; // key_press; ̬
    uint8_t key_return = 0xFF;  // KEY_NO = 0

	keycode = keypad_scan(); // ɨ̣ȡֵ

	// ״̬
    switch (key_state)
    {
        case KEY_STATE_0:  // ʼ״̬ʱûм
            if (keycode != 0xFF)
			{
				keymaybe = keycode; // ¼ܱµļֵŵ̬ keymaybe 
				key_state = KEY_STATE_1;// м(ûм£ 0xFF)ȷ״̬
			}
            break;
        case KEY_STATE_1:  // ʱ֮ٴȷϼǷȻ»Ѿͷ
            if (keycode == keymaybe) // ϴΰµļͬ
            {
				key_return = keypad_lookup(keycode); // мˣü̷ţ '1', '2'
                key_state = KEY_STATE_2;  // ״̬ΪǷͷ״̬
            }
            else
                key_state = KEY_STATE_0; // ҪжϺϴΰļͬǱͷţתʼ״̬
            break; // ˳ switch 䣬ںĽβؼֵ
        case KEY_STATE_2:
            if (keycode == 0xFF) key_state = KEY_STATE_0; // ͷţлʼ״̬
            break;
    }

    return key_return;
}

// if mute = 1: active
// if mute = 0: deactive
void mute(uint8_t mute)
{
	uint8_t i;

	if (mute) {
		PORTB |= (1 << PB7); // set high, mute
		for (i=0; i<20; i++)
			_delay_ms(10);
	}
	else {
		PORTB &= ~(1 << PB7); // set low, exit mute
		for (i=0; i<20; i++)
			_delay_ms(10);
	}
}

void greeting(void)
{
	uint8_t i;

	lcd_clrscr();
	lcd_gotoxy(0, 0);
	lcd_puts_p(dedicated_line0);
	lcd_gotoxy(0, 1);
	lcd_puts_p(dedicated_line1);

	// delay 2 seconds
	for (i=0; i<100; i++)
		_delay_ms(10);

	lcd_clrscr();
}

struct photoram read_photo(uint8_t keycode)
{
	uint8_t keynum, i;
	struct photoram pho;

	keynum = keynum_lookup(keycode); // ѷűɴ 1  16 

	if  (keynum < 10)
		pho.id[0] = ' ';
	else
		pho.id[0] = 0x30 + (keynum / 10);

	pho.id[1] = 0x30 + (keynum % 10);

	i = 0;
	while ( (pho.name[i] = eeprom_read_byte((uint8_t *)(photo[keynum-1].name + i))) ) {
		i++;
	}

	i = 0;
	while ( (pho.number[i] = eeprom_read_byte((uint8_t *)(photo[keynum-1].number + i))) ) {
		i++;
	}

	return pho;
}

void clear_name_line(void)
{
	lcd_gotoxy(8, 1);
	lcd_puts_p(name_line_spaces);
}

void clear_number_line(void)
{
	lcd_gotoxy(4, 2);
	lcd_puts_p(number_line_spaces);
}

void dial_photo(char *number)
{
   	while (*number)
		dtmf(*number++);
}

int main(void)
{
	uint8_t foto = 0;
	uint8_t buttoncode;
	uint8_t keycode;
	struct photoram ph, foto_view;

    // Initial state variables
    init(); // ʹ
    sei();  // ȫжʹ

	greeting();
	lcd_gotoxy(0, 1);
	lcd_puts("Foto   :");

	lcd_gotoxy(0, 2);
	lcd_puts("Tel:");


/*
1. timer0 overflow жϷǷ


*/
	while (1)
    {
		// 1OK
		// 100ms  OK
		// 20ms  OK
		if (key_scan_time_ok)
		{
			key_scan_time_ok = 0;
			
/***********************************************************/
			// scan 4*4 keypad
			keycode = keypad_get_key();
			if (keycode != 0xFF) {
				ph = read_photo(keycode); //  eeprom ж͵绰

				clear_name_line();   // Ϊ̲һ
				lcd_gotoxy(5, 1);    // ʾƬ
				lcd_putc(ph.id[0]);
				lcd_gotoxy(6, 1);    // ʾƬ
				lcd_putc(ph.id[1]);
		        lcd_gotoxy(8, 1);    // ڶ
				lcd_puts(ph.name);   // ʾ

				clear_number_line(); // 
		        lcd_gotoxy(4, 2);  // 
				lcd_puts(ph.number); // ʾ绰

 				// ַĳȲΪ0 Ų
				if (strlen(ph.number)) {
					mute(1);
					dial_photo(ph.number); // 
					mute(0);
				}

			}

/***********************************************************/
			buttoncode = read_button(); //  6 С

			// Ч
			if (buttoncode)
			{
			}
/***********************************************************/
		}
    }
}

